#include <cstdlib>
#include <iostream>
#include <cmath>

using namespace std;

struct Node {
  int num1;
  int num2;
  Node *left;
  Node *right;

  Node(int n1, int n2){
    num1 = n1;
    num2 = n2;
    left = NULL;
    right = NULL;
  }
};

//------------------------------------------------------------------------------
void insert(Node *&root, int n1, int n2);
void printInOrder(Node *root);
void printModifiedInOrder(Node *root, int N);

//------------------------------------------------------------------------------
int main(int argc, char *argv[])
{
    Node *root;
    root = NULL;
    
    insert(root, 25, 10);
    insert(root, 50, 15);
    insert(root, 17, 2);
    insert(root, -1, 3);
    insert(root, 1, 20);
    insert(root, 27, 12);
    insert(root, 27, 11);
    
    if (root != NULL)
      printInOrder(root);
      
    cout << endl << endl;
    
    if (root != NULL)
      printModifiedInOrder(root, 15);
    
    system("PAUSE");
    return EXIT_SUCCESS;
}

//------------------------------------------------------------------------------
void insert(Node *&root, int n1, int n2){
  if (root == NULL) {
    root = new Node(n1, n2);
  }
  else if ((n1+n2) < (root->num1 + root->num2)){
    insert(root->left, n1, n2);
  }
  else {
    insert(root->right, n1, n2);
  }
}

//------------------------------------------------------------------------------
void printInOrder(Node *root) {
  if (root != NULL){
    printInOrder(root->left);
    cout << root->num1 << "  " << root->num2 
         <<  "   Suma: " << root->num1 + root->num2
         <<  "   Skirtumas: " << abs(root->num1 - root->num2) << endl;
    printInOrder(root->right);
  }     
}

//------------------------------------------------------------------------------
void printModifiedInOrder(Node *root, int N) {
  if (root != NULL){
    printModifiedInOrder(root->left, N);
    if ((abs(root->num1 - root->num2)) <= N){
    cout << root->num1 << "  " << root->num2 
         <<  "   Suma: " << root->num1 + root->num2
         <<  "   Skirtumas: " << abs(root->num1 - root->num2) << endl;
    }
    printModifiedInOrder(root->right, N);
  }     
}
